var getType = function (x) {
  var str = Object.prototype.toString.call(x),
      longType = str.substring(8, str.length - 1);
  return longType.toLowerCase();
};

exports.getType = getType;

exports.encode = function (value) {
  return (() => {
    switch (getType(value)) {
      case "string":
        return ":" + value;

      default:
        return String(value);
    }
  })();
};

exports.decode = function (text) {
  if (text.match(/^:/)) {
    return text.substr(1);
  }

  if (text.match(/^[-\d]+/)) {
    return Number(text);
  }

  if (text.match(/^\//)) {
    var content = text.substr(1);
    content = content.replace(/\//, "\\/");
    return new RegExp(text.substr(1));
  }

  return (() => {
    switch (text) {
      case "true":
        return true;

      case "false":
        return false;

      case "undefined":
        return undefined;

      case "null":
        return null;

      case "Infinity":
        return Infinity;

      default:
        throw new Error("not a valid value: " + JSON.stringify(text));
        return a;
    }
  })();
};